Index: XIOS3/trunk/src/manager/ressources_manager.cpp
===================================================================
--- XIOS3/trunk/src/manager/ressources_manager.cpp	(revision 2561)
+++ XIOS3/trunk/src/manager/ressources_manager.cpp	(revision 2562)
@@ -43,4 +43,5 @@
     delete winNotify_ ;
     delete winRessources_ ;
+    delete tokenManager_ ;
   } 
 
Index: XIOS3/trunk/src/transport/p2p_client_buffer.cpp
===================================================================
--- XIOS3/trunk/src/transport/p2p_client_buffer.cpp	(revision 2561)
+++ XIOS3/trunk/src/transport/p2p_client_buffer.cpp	(revision 2562)
@@ -229,4 +229,5 @@
       if (flag==true)
       {
+        info(logProtocol) << "DBG : Send req deleted to "  << intraServerRank_ << ", of size " << request.buffer->count() << endl;
         delete request.buffer ;
         requests_.pop_front() ;
@@ -300,5 +301,8 @@
     }
     if (info.isActive(logProtocol)) CTimer::get("sendTimelineEvent : MPI_Isend").resume() ;
+    info(logProtocol) << "DBG : Send Hdr to "  << intraServerRank_ << ", of size " << request.buffer->count() << endl;
     MPI_Isend(request.buffer->start(),request.buffer->count(), MPI_CHAR, intraServerRank_, 20, interCommMerged_, &request.mpiRequest ) ;
+    //MPI_Send(request.buffer->start(),request.buffer->count(), MPI_CHAR, intraServerRank_, 20, interCommMerged_ ) ;
+    //delete request.buffer ;	    
     if (info.isActive(logProtocol)) CTimer::get("sendTimelineEvent : MPI_Isend").suspend() ;
     info(logProtocol)<<outStr.str()<<endl ;
@@ -311,5 +315,8 @@
     request.buffer = new CBufferOut(sizeof(EVENT_BUFFER_RESIZE)+sizeof(timeline)+sizeof(size)) ; 
     *(request.buffer)<<EVENT_BUFFER_RESIZE<<timeline<<size ;
+    info(logProtocol) << "DBG : Send Hdr RESIZE to "  << intraServerRank_ << ", of size " << request.buffer->count() << endl;
     MPI_Isend(request.buffer->start(),request.buffer->count(), MPI_CHAR, intraServerRank_, 20, interCommMerged_, &request.mpiRequest ) ;
+    //MPI_Send(request.buffer->start(),request.buffer->count(), MPI_CHAR, intraServerRank_, 20, interCommMerged_ ) ;
+    //delete request.buffer ;
     requests_.push_back(request) ;
   }
Index: XIOS3/trunk/src/transport/p2p_context_server.cpp
===================================================================
--- XIOS3/trunk/src/transport/p2p_context_server.cpp	(revision 2561)
+++ XIOS3/trunk/src/transport/p2p_context_server.cpp	(revision 2562)
@@ -104,4 +104,7 @@
         requests_[rank].push_back(new CRequest(interCommMerged_, status)) ;
         // Test 1st request of the list, request treatment must be ordered 
+        //while (!requests_[rank].back()->test()) 
+        //{
+        //}
         if (requests_[rank].front()->test())
         {
@@ -110,4 +113,7 @@
           requests_[rank].pop_front() ;
         }
+        //CRequest* request = new CRequest(interCommMerged_, status);
+        //processRequest(*request) ;
+        //delete request;
       }
     }
@@ -134,8 +140,9 @@
     if (it==buffers_.end())
     {
+      info(logProtocol) << "DBG : Buffer(Hdr) created "  << rank << ", of size " << request.getCount() << endl;
       buffers_[rank] = new CP2pServerBuffer(rank, commSelf_, interCommMerged_, pendingEvents_, completedEvents_, request.getBuffer()) ;
     }
-    else
-    {
+    else {
+      info(logProtocol) << "DBG : Buffer(Hdr) received "  << rank << ", of size " << request.getCount() << endl;
       it->second->receivedRequest(request.getBuffer()) ;
     }
Index: XIOS3/trunk/src/transport/p2p_context_server.hpp
===================================================================
--- XIOS3/trunk/src/transport/p2p_context_server.hpp	(revision 2561)
+++ XIOS3/trunk/src/transport/p2p_context_server.hpp	(revision 2562)
@@ -36,8 +36,11 @@
             MPI_Get_count(&status,MPI_CHAR,&count_);
             buffer_.resize(count_) ;
+            info(logProtocol) << "DBG : Request created from "  << rank_ << ", of size " << count_ << endl;
             MPI_Irecv(buffer_.data(), count_, MPI_CHAR, rank_, 20, interComm, &request_) ;
+            //MPI_Status mpistatus;
+            //MPI_Recv(buffer_.data(), count_, MPI_CHAR, rank_, 20, interComm, &mpistatus) ;
           }
           
-          ~CRequest() { }
+          ~CRequest() { info(logProtocol) << "DBG : Request deleted "  << rank_ << ", of size " << count_ << endl; }
 
           bool test(void)
@@ -46,5 +49,8 @@
             MPI_Status status ;
             MPI_Test(&request_, &flag, &status) ;
-            if (flag==true) return true ;
+            if (flag==true) {
+	      info(logProtocol) << "DBG : Request completed "  << rank_ << ", of size " << count_ << endl;
+	      return true ;
+	    }
             else return false ;
           }