Index: XIOS3/trunk/src/transport/p2p_client_buffer.cpp
===================================================================
--- XIOS3/trunk/src/transport/p2p_client_buffer.cpp	(revision 2562)
+++ XIOS3/trunk/src/transport/p2p_client_buffer.cpp	(revision 2563)
@@ -229,5 +229,4 @@
       if (flag==true)
       {
-        info(logProtocol) << "DBG : Send req deleted to "  << intraServerRank_ << ", of size " << request.buffer->count() << endl;
         delete request.buffer ;
         requests_.pop_front() ;
@@ -301,8 +300,5 @@
     }
     if (info.isActive(logProtocol)) CTimer::get("sendTimelineEvent : MPI_Isend").resume() ;
-    info(logProtocol) << "DBG : Send Hdr to "  << intraServerRank_ << ", of size " << request.buffer->count() << endl;
     MPI_Isend(request.buffer->start(),request.buffer->count(), MPI_CHAR, intraServerRank_, 20, interCommMerged_, &request.mpiRequest ) ;
-    //MPI_Send(request.buffer->start(),request.buffer->count(), MPI_CHAR, intraServerRank_, 20, interCommMerged_ ) ;
-    //delete request.buffer ;	    
     if (info.isActive(logProtocol)) CTimer::get("sendTimelineEvent : MPI_Isend").suspend() ;
     info(logProtocol)<<outStr.str()<<endl ;
@@ -315,8 +311,5 @@
     request.buffer = new CBufferOut(sizeof(EVENT_BUFFER_RESIZE)+sizeof(timeline)+sizeof(size)) ; 
     *(request.buffer)<<EVENT_BUFFER_RESIZE<<timeline<<size ;
-    info(logProtocol) << "DBG : Send Hdr RESIZE to "  << intraServerRank_ << ", of size " << request.buffer->count() << endl;
     MPI_Isend(request.buffer->start(),request.buffer->count(), MPI_CHAR, intraServerRank_, 20, interCommMerged_, &request.mpiRequest ) ;
-    //MPI_Send(request.buffer->start(),request.buffer->count(), MPI_CHAR, intraServerRank_, 20, interCommMerged_ ) ;
-    //delete request.buffer ;
     requests_.push_back(request) ;
   }
Index: XIOS3/trunk/src/transport/p2p_context_server.cpp
===================================================================
--- XIOS3/trunk/src/transport/p2p_context_server.cpp	(revision 2562)
+++ XIOS3/trunk/src/transport/p2p_context_server.cpp	(revision 2563)
@@ -104,7 +104,4 @@
         requests_[rank].push_back(new CRequest(interCommMerged_, status)) ;
         // Test 1st request of the list, request treatment must be ordered 
-        //while (!requests_[rank].back()->test()) 
-        //{
-        //}
         if (requests_[rank].front()->test())
         {
@@ -113,7 +110,4 @@
           requests_[rank].pop_front() ;
         }
-        //CRequest* request = new CRequest(interCommMerged_, status);
-        //processRequest(*request) ;
-        //delete request;
       }
     }
@@ -140,9 +134,8 @@
     if (it==buffers_.end())
     {
-      info(logProtocol) << "DBG : Buffer(Hdr) created "  << rank << ", of size " << request.getCount() << endl;
       buffers_[rank] = new CP2pServerBuffer(rank, commSelf_, interCommMerged_, pendingEvents_, completedEvents_, request.getBuffer()) ;
     }
-    else {
-      info(logProtocol) << "DBG : Buffer(Hdr) received "  << rank << ", of size " << request.getCount() << endl;
+    else
+    {
       it->second->receivedRequest(request.getBuffer()) ;
     }
Index: XIOS3/trunk/src/transport/p2p_context_server.hpp
===================================================================
--- XIOS3/trunk/src/transport/p2p_context_server.hpp	(revision 2562)
+++ XIOS3/trunk/src/transport/p2p_context_server.hpp	(revision 2563)
@@ -36,11 +36,8 @@
             MPI_Get_count(&status,MPI_CHAR,&count_);
             buffer_.resize(count_) ;
-            info(logProtocol) << "DBG : Request created from "  << rank_ << ", of size " << count_ << endl;
             MPI_Irecv(buffer_.data(), count_, MPI_CHAR, rank_, 20, interComm, &request_) ;
-            //MPI_Status mpistatus;
-            //MPI_Recv(buffer_.data(), count_, MPI_CHAR, rank_, 20, interComm, &mpistatus) ;
           }
           
-          ~CRequest() { info(logProtocol) << "DBG : Request deleted "  << rank_ << ", of size " << count_ << endl; }
+          ~CRequest() { }
 
           bool test(void)
@@ -49,8 +46,5 @@
             MPI_Status status ;
             MPI_Test(&request_, &flag, &status) ;
-            if (flag==true) {
-	      info(logProtocol) << "DBG : Request completed "  << rank_ << ", of size " << count_ << endl;
-	      return true ;
-	    }
+            if (flag==true) return true ;
             else return false ;
           }