Index: XIOS3/trunk/src/interface/fortran/ilogical_bool_conversion.f90
===================================================================
--- XIOS3/trunk/src/interface/fortran/ilogical_bool_conversion.f90	(revision 2620)
+++ XIOS3/trunk/src/interface/fortran/ilogical_bool_conversion.f90	(revision 2622)
@@ -21,5 +21,5 @@
     ctrue  =  cxios_set_logical_true()
     cfalse =  cxios_set_logical_false()
-    if (tmp.eq..false.) then
+    if (tmp.eqv..false.) then
       tmp = cfalse
     else
@@ -37,5 +37,5 @@
     cfalse =  cxios_set_logical_false()
     do ij=1,ni_(1)
-       if (tmp(ij).eq..false.) then
+       if (tmp(ij).eqv..false.) then
           tmp(ij) = cfalse
        else
@@ -55,5 +55,5 @@
     do j=1,ni_(2)
       do i=1,ni_(1)
-        if (tmp(i,j).eq..false.) then
+        if (tmp(i,j).eqv..false.) then
           tmp(i,j) = cfalse
         else
@@ -75,5 +75,5 @@
       do j=1,ni_(2)
         do i=1,ni_(1)
-          if (tmp(i,j,k).eq..false.) then
+          if (tmp(i,j,k).eqv..false.) then
             tmp(i,j,k) = cfalse
           else
@@ -97,5 +97,5 @@
         do j=1,ni_(2)
           do i=1,ni_(1)
-            if (tmp(i,j,k,l).eq..false.) then
+            if (tmp(i,j,k,l).eqv..false.) then
               tmp(i,j,k,l) = cfalse
             else
@@ -121,5 +121,5 @@
           do j=1,ni_(2)
             do i=1,ni_(1)
-              if (tmp(i,j,k,l,m).eq..false.) then
+              if (tmp(i,j,k,l,m).eqv..false.) then
                 tmp(i,j,k,l,m) = cfalse
               else
@@ -147,5 +147,5 @@
             do j=1,ni_(2)
               do i=1,ni_(1)
-                if (tmp(i,j,k,l,m,p).eq..false.) then
+                if (tmp(i,j,k,l,m,p).eqv..false.) then
                   tmp(i,j,k,l,m,p) = cfalse
                 else
@@ -175,5 +175,5 @@
               do j=1,ni_(2)
                 do i=1,ni_(1)
-                  if (tmp(i,j,k,l,m,p,q).eq..false.) then
+                  if (tmp(i,j,k,l,m,p,q).eqv..false.) then
                     tmp(i,j,k,l,m,p,q) = cfalse
                   else
@@ -193,5 +193,5 @@
     IMPLICIT NONE
     LOGICAL (KIND=C_BOOL), INTENT(INOUT) :: tmp
-    if (tmp.eq..false.) then
+    if (tmp.eqv..false.) then
       tmp = .false.
     else
@@ -206,5 +206,5 @@
     INTEGER :: ij
     do ij=1,ni_(1)
-       if (tmp(ij).eq..false.) then
+       if (tmp(ij).eqv..false.) then
           tmp(ij) = .false.
        else
@@ -221,5 +221,5 @@
     do j=1,ni_(2)
       do i=1,ni_(1)
-        if (tmp(i,j).eq..false.) then
+        if (tmp(i,j).eqv..false.) then
           tmp(i,j) = .false.
         else
@@ -238,5 +238,5 @@
       do j=1,ni_(2)
         do i=1,ni_(1)
-          if (tmp(i,j,k).eq..false.) then
+          if (tmp(i,j,k).eqv..false.) then
             tmp(i,j,k) = .false.
           else
@@ -257,5 +257,5 @@
         do j=1,ni_(2)
           do i=1,ni_(1)
-            if (tmp(i,j,k,l).eq..false.) then
+            if (tmp(i,j,k,l).eqv..false.) then
               tmp(i,j,k,l) = .false.
             else
@@ -278,5 +278,5 @@
           do j=1,ni_(2)
             do i=1,ni_(1)
-              if (tmp(i,j,k,l,m).eq..false.) then
+              if (tmp(i,j,k,l,m).eqv..false.) then
                 tmp(i,j,k,l,m) = .false.
               else
@@ -301,5 +301,5 @@
             do j=1,ni_(2)
               do i=1,ni_(1)
-                if (tmp(i,j,k,l,m,p).eq..false.) then
+                if (tmp(i,j,k,l,m,p).eqv..false.) then
                   tmp(i,j,k,l,m,p) = .false.
                 else
@@ -326,5 +326,5 @@
               do j=1,ni_(2)
                 do i=1,ni_(1)
-                  if (tmp(i,j,k,l,m,p,q).eq..false.) then
+                  if (tmp(i,j,k,l,m,p,q).eqv..false.) then
                     tmp(i,j,k,l,m,p,q) = .false.
                   else
@@ -340,19 +340,4 @@
   END SUBROUTINE xios_bool_to_logical_7d
   
-  !SUBROUTINE xios_bool_to_logical_0d(tmp, ni_)
-  !  IMPLICIT NONE
-  !  LOGICAL (KIND=C_BOOL), INTENT(INOUT) :: tmp(:)
-  !  INTEGER, INTENT(IN) :: ni_(:)
-  !  INTEGER :: ij
-  !  do ij=1,ni_(1)
-  !     if (tmp(ij).eq..false.) then
-  !        tmp(ij) = .false.
-  !     else
-  !        tmp(ij) = .true.
-  !     endif
-  !  enddo
-  !END SUBROUTINE xios_bool_to_logical_0d
-
-
 END MODULE logical_bool_conversion
 